
            /*  demotext.c,  Test Program for textgraf.c  */

            /*       Copyright (c) 1990, John Ryon        */ 

#include  <graphics.h>

#define   __USE_BGI_TEXT__    /* Enable both BGI and replacements for demo. */
                              /* Normally not needed.  Calls to BGI will */
                              /* normally be redirected to replacements. */
#include  "graftext.h"

void TestSize( void );
void TestJustify( void );

char ProceedMsg[] = "Press a key to go on...";

void main( void )
{
   int Driver = 0, Mode, grResult;

   initgraph( &Driver, &Mode, "" );
   if ( (grResult = graphresult()) != grOk )
   {
      printf( "Graphics error: %s\n", grapherrormsg( grResult ) );
      exit(1);
   }

   clearviewport();  TestJustify();

   clearviewport();  TestSize();

   closegraph();
}

void TestJustify( void )
{
   int I, J, Imax, Jmax, Wide, High;
   char RightTextB[] = "Right justified by Borland",
        RightTextC[] = "Right justified, corrected";

   Imax = getmaxx();  Jmax = getmaxy();

   SetTextStyle( SANS_SERIF_FONT, HORIZ_DIR, 1 );    /* replacement */
   I = Imax/2;  J = Jmax/2;
   line( I, 0, I, Jmax );

   settextjustify( RIGHT_TEXT, BOTTOM_TEXT );
   outtextxy( I, J, RightTextB );                 /* Borland */

   settextjustify( RIGHT_TEXT, TOP_TEXT );
   OutTextXY( I, J, RightTextC );                 /* Better */

   settextjustify( LEFT_TEXT, TOP_TEXT );
   OutTextXY( 0, 0, ProceedMsg );
   getch();
}

void TestSize( void )
{
   int I, J, Imax, Jmax, Wide, High;
   char SampleText[] = "Sample Text String";

   SetTextStyle( SANS_SERIF_FONT, HORIZ_DIR, 1 );
   settextjustify( LEFT_TEXT, TOP_TEXT );

   Imax = getmaxx();  Jmax = getmaxy();

   for ( J = 0,  Wide = (Imax+1)/8,  High = (Jmax+1)/16;
         J < Jmax;
         Wide *= 2, High *= 2 )
   {
      SetTextSize( SampleText, Wide, High );  /* Set pixel size of text */
      OutTextXY( 0, J, SampleText );
      J += High;
   }

   for ( J = 0,  I = (Imax+1)/8,  High = (Jmax+1)/16;
         J < Jmax/2;
         I *= 2, High *= 2 )
   {
      Wide = Imax - I;
      OutTextXYWH( I, J, Wide, High, SampleText );  /* set size & out txt */
      J += High;
   }

   SetTextStyle( SANS_SERIF_FONT, HORIZ_DIR, 1 );
   OutTextXY( 0, Jmax/2 + Jmax/16, ProceedMsg );
   getch();
}
